package com.company;

import java.util.Calendar;

public class Worker {
    protected String name;
    protected String surname;
    protected String PESEL;
    protected int yearOfBirth;
    protected int yearOfEmployment;
    protected char gender;
    protected String company;
    protected String occupation;

    public Worker(String name, String surname, String PESEL, int yearOfBirth, int yearOfEmployment, char gender, String company, String occupation) {
        this.name = name;
        this.surname = surname;
        this.PESEL = PESEL;
        this.yearOfBirth = yearOfBirth;
        this.yearOfEmployment = yearOfEmployment;
        this.gender = gender;
        this.company = company;
        this.occupation = occupation;
    }

    public Worker() {
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getSurname() {
        return surname;
    }

    public void setSurname(String surname) {
        this.surname = surname;
    }

    public String getPESEL() {
        return PESEL;
    }

    public void setPESEL(String PESEL) {
        this.PESEL = PESEL;
    }

    public int getYearOfBirth() {
        return yearOfBirth;
    }

    public void setYearOfBirth(int yearOfBirth) {
        this.yearOfBirth = yearOfBirth;
    }

    public int getYearOfEmployment() {
        return yearOfEmployment;
    }

    public void setYearOfEmployment(int yearOfEmployment) {
        this.yearOfEmployment = yearOfEmployment;
    }

    public char getGender() {
        return gender;
    }

    public void setGender(char gender) {
        this.gender = gender;
    }

    public String getCompany() {
        return company;
    }

    public void setCompany(String company) {
        this.company = company;
    }

    public String getOccupation() {
        return occupation;
    }

    public void setOccupation(String occupation) {
        this.occupation = occupation;
    }

    @Override
    public String toString() {
        return "Worker{" +
                "name='" + name + '\'' +
                ", surname='" + surname + '\'' +
                ", PESEL='" + PESEL + '\'' +
                ", yearOfBirth=" + yearOfBirth +
                ", yearOfEmployment=" + yearOfEmployment +
                ", gender=" + gender +
                ", company='" + company + '\'' +
                ", occupation='" + occupation + '\'' +
                '}';
    }

    public int getAge(){
        return Calendar.getInstance().get(Calendar.YEAR) - yearOfBirth;
    }

    public int calculateJobSeniority(){
        return Calendar.getInstance().get(Calendar.YEAR) - yearOfEmployment;
    }

    public int calculateTimeToRetirement(){
        if(gender == 'M') {
            return 65 - getAge();
        } else {
            return 60 - getAge();
        }
    }

    public void display(){
        System.out.println("Name and surname: " + name + " " + surname);
        System.out.println("PESEL: " + PESEL);
        System.out.println("Year of birth: " + yearOfBirth);
        System.out.println("Age: " + getAge());
        System.out.println("Year of employment: " + yearOfEmployment);
        System.out.println("Job seniority: " + calculateJobSeniority());
        System.out.println("Company name: " + company);
        System.out.println("Occupation: " + occupation);
    }

}
